#ifndef _H_5507559D03D4BE391009F795AA9E6A30_Statistics_DCPS_H_
#define _H_5507559D03D4BE391009F795AA9E6A30_Statistics_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Statistics_.h"


namespace py_trees_ros_interfaces
{
    namespace msg
    {
        namespace dds_
        {
            class Statistics_TypeSupportInterface;

            typedef Statistics_TypeSupportInterface * Statistics_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Statistics_TypeSupportInterface> Statistics_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Statistics_TypeSupportInterface> Statistics_TypeSupportInterface_out;


            class Statistics_DataWriter;

            typedef Statistics_DataWriter * Statistics_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Statistics_DataWriter> Statistics_DataWriter_var;
            typedef DDS_DCPSInterface_out < Statistics_DataWriter> Statistics_DataWriter_out;


            class Statistics_DataReader;

            typedef Statistics_DataReader * Statistics_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Statistics_DataReader> Statistics_DataReader_var;
            typedef DDS_DCPSInterface_out < Statistics_DataReader> Statistics_DataReader_out;


            class Statistics_DataReaderView;

            typedef Statistics_DataReaderView * Statistics_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Statistics_DataReaderView> Statistics_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Statistics_DataReaderView> Statistics_DataReaderView_out;

            struct Statistics_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Statistics_, struct Statistics_Seq_uniq_> Statistics_Seq;
            typedef DDS_DCPSSequence_var < Statistics_Seq> Statistics_Seq_var;
            typedef DDS_DCPSSequence_out < Statistics_Seq> Statistics_Seq_out;

            class  Statistics_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Statistics_TypeSupportInterface_ptr _ptr_type;
                typedef Statistics_TypeSupportInterface_var _var_type;

                static Statistics_TypeSupportInterface_ptr _duplicate (Statistics_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Statistics_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Statistics_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Statistics_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Statistics_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Statistics_TypeSupportInterface () {};
                ~Statistics_TypeSupportInterface () {};
            private:
                Statistics_TypeSupportInterface (const Statistics_TypeSupportInterface &);
                Statistics_TypeSupportInterface & operator = (const Statistics_TypeSupportInterface &);
            };

            class  Statistics_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Statistics_DataWriter_ptr _ptr_type;
                typedef Statistics_DataWriter_var _var_type;

                static Statistics_DataWriter_ptr _duplicate (Statistics_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Statistics_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Statistics_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Statistics_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Statistics_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Statistics_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Statistics_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Statistics_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Statistics_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Statistics_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Statistics_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Statistics_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Statistics_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Statistics_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Statistics_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Statistics_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Statistics_& instance_data) = 0;

            protected:
                Statistics_DataWriter () {};
                ~Statistics_DataWriter () {};
            private:
                Statistics_DataWriter (const Statistics_DataWriter &);
                Statistics_DataWriter & operator = (const Statistics_DataWriter &);
            };

            class  Statistics_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Statistics_DataReader_ptr _ptr_type;
                typedef Statistics_DataReader_var _var_type;

                static Statistics_DataReader_ptr _duplicate (Statistics_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Statistics_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Statistics_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Statistics_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Statistics_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Statistics_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Statistics_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Statistics_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Statistics_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Statistics_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Statistics_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Statistics_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Statistics_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Statistics_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Statistics_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Statistics_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Statistics_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Statistics_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Statistics_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Statistics_& instance) = 0;

            protected:
                Statistics_DataReader () {};
                ~Statistics_DataReader () {};
            private:
                Statistics_DataReader (const Statistics_DataReader &);
                Statistics_DataReader & operator = (const Statistics_DataReader &);
            };

            class  Statistics_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Statistics_DataReaderView_ptr _ptr_type;
                typedef Statistics_DataReaderView_var _var_type;

                static Statistics_DataReaderView_ptr _duplicate (Statistics_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Statistics_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Statistics_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Statistics_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Statistics_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Statistics_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Statistics_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Statistics_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Statistics_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Statistics_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Statistics_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Statistics_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Statistics_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Statistics_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Statistics_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Statistics_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Statistics_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Statistics_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Statistics_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Statistics_& instance) = 0;

            protected:
                Statistics_DataReaderView () {};
                ~Statistics_DataReaderView () {};
            private:
                Statistics_DataReaderView (const Statistics_DataReaderView &);
                Statistics_DataReaderView & operator = (const Statistics_DataReaderView &);
            };
        }

    }

}

#endif
